Name:		hp-i40e
Version:	2.4.6.1
Release:	4.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://www.intel.com/network/connectivity/products/server_adapters.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	HP Intel i40e Ethernet Kernel Module

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
This package provides the HP Intel i40e Ethernet Kernel Module.
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: HP Intel i40e Ethernet Kernel Module
Group: System/Kernel

%description KMP
This package provides the HP Intel i40e Ethernet Kernel Module.
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the HP Intel i40e Ethernet Kernel Module

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override i40e * weak-updates/%{name}" > %{name}.conf

%build
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
        make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/i40e.7 > source/i40e.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
        make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} rpm

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/i40e.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/i40e.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/i40e.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/i40e.7.gz
%doc source/COPYING source/README

%changelog
* Wed May 16 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
- This driver fixes the issue of TX driver on SLES12SP2
- This driver fixes the issue of Flow Director User documentation - README.TXT is not current
- This driver fixes the issue of submodules updating
- This driver fixes the issue of client close on Netdev down causing RDMA dev to unregister  
- This driver fixes the issue of unexpected queue selection messages observed during tx_timeout recovery  
- This driver now preserves promiscuous mode across resets

* Tue Oct 31 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.3.6-1
- This driver addresses an issue with branding string in RHEL7.4
- This driver now fix the issue of LIS prevents switching back to the VF path in RHEL 7.3 guest
- This driver now alllows to use ethtool -m on DAC with or without NPAR
- This driver fixes the supported autoneg for devices with CRT_RETIMER
- This driver now ignores locality when spreading vectors over CPUs
- This driver now allows to change VLAN Tag Stripping
- This driver now throws an error after attempt to advertise unsupported link mode
- This driver now allows to set MTU value to more than 1500 in SLES12SP3 with Intel NICs
- This driver fixes the issue of ethtool not showing up dual-speed modules advertisements
- This driver fixes the issue of memory leak related to filter programming status
- This driver fixes the issue of Flow Director Sideband rules do not update as expected
- This driver fixes the issue of Could not change device features with Adapter Type SR-IOV passthrough and VSwitch VLAN Tagging Mode
- This driver fixes the issue of VxLAN checksum offload counter increments without VxLAN tunnels present
- This driver fixes the issue of kdump failure
- Feature implemention for split PCI error reset handler
- Feature implementation to return an error message when module that does not meet thermal requirements is plugged.
- Feature implementation to add some hw_csum rx offload counters
- Feature implementation to add wrap recovery mode.
- Feature implementation to add ethtool_intersect_link_masks.

* Fri Jul 28 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.0.29-3
- Added support for HPE Ethernet 1Gb 2-port 368i Adapter
- Added support for HPE Ethernet 1Gb 4-port 369i Adapter
- Added support for HPE Ethernet 1Gb 2-port 368FLR-MMT Adapter
- Added support for HPE Ethernet 10Gb 2-port 568FLR-MMT Adapter
- Added support for HPE Ethernet 10Gb 2-port 568FLR-MMSFP+ Adapter
- Added SLES12SP3 support
- Added RHEL7.4 support

* Tue Mar 21 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.0.19-2[rhel6u9], 2.0.19-1[For other OSs]
- Fix for configuration of RSS table with DCB
- Enabled VF trust on RHEL 7.3
- Added support for HPE Ethernet 10Gb 2-port 568i Adapter
- Added SLES12SP2 support
- Added RHEL7.3 support
- Feature implementation for speading out interrupts and to use all rx queues and all cpus
- Fix for NVM update process hangs on Linux at 88%

* Tue Jun 21 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.3.46.2-1.rhel6u8
- Added RHEL6.8 support

* Wed Apr 13 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.3.46-13
-Added support for  HPE Ethernet 10Gb 2-port 563i Adapter

* Tue Nov 10 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.3.46-5
 - Added support for SLES12SP1
 - Added support for RHEL 7.2
 - This driver addresses an issue where firmware version information reporting is incorrect and inconsistent.
 - This driver now correctly sets the default value of the Flow Control setting after a device reset.

* Tue Jul 07 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.2.45-9
 - Added support for SLES11SP4
 - Added support for RHEL 6.7

* Mon Apr 06 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 1.2.45-1
  - Initial release of i40e Linux Base Driver for Intel(R) 40 Gigabit Network Connections
